'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProfileType = exports.ProfileContext = exports.Profile = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tcomb = require('tcomb');

var _uri = require('rheactor-value-objects/uri');

var _uri2 = _interopRequireDefault(_uri);

var _email = require('rheactor-value-objects/email');

var _email2 = _interopRequireDefault(_email);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @type Profile
 */
var Profile = exports.Profile = function () {
  /**
   * @param {{email: {EmailValue}, firstname: {String}, lastname: {String}, avatar: {URIValue}}} fields
   */
  function Profile(fields) {
    _classCallCheck(this, Profile);

    var email = fields.email,
        firstname = fields.firstname,
        lastname = fields.lastname,
        avatar = fields.avatar;

    (0, _tcomb.String)(firstname);
    (0, _tcomb.String)(lastname);
    _email2.default.Type(email);
    (0, _tcomb.maybe)(_uri2.default.Type)(avatar);
    this.email = email;
    this.firstname = firstname;
    this.lastname = lastname;
    this.avatar = avatar;
    this.$context = ProfileContext;
  }

  /**
   * @returns {string}
   */


  _createClass(Profile, [{
    key: 'toJSON',


    /**
     * @returns {{email: {String}, firstname: {String}, lastname: {String}, avatar: ({String}|undefined), $context: {String}}}
     */
    value: function toJSON() {
      return {
        email: this.email.toString(),
        firstname: this.firstname,
        lastname: this.lastname,
        avatar: this.avatar ? this.avatar.toString() : undefined,
        $context: this.$context
      };
    }

    /**
     * @param {{email: {String}, firstname: {String}, lastname: {String}, avatar: {String}}} data
     * @returns {Profile}
     */

  }, {
    key: 'name',
    get: function get() {
      var name = this.firstname;
      if (name.length) name = name + ' ';
      name = name + this.lastname;
      return name;
    }
  }], [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      var email = data.email,
          firstname = data.firstname,
          lastname = data.lastname,
          avatar = data.avatar;

      return new Profile({
        email: new _email2.default(email),
        firstname: firstname,
        lastname: lastname,
        avatar: avatar ? new _uri2.default(avatar) : avatar
      });
    }
  }]);

  return Profile;
}();

var ProfileContext = exports.ProfileContext = 'https://github.com/ResourcefulHumans/staRHs-models#Profile';
var ProfileType = exports.ProfileType = (0, _tcomb.irreducible)('ProfileType', function (x) {
  return x instanceof Profile;
});