'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StaRHsStatusType = exports.StaRHsStatusContext = exports.StaRHsStatus = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tcomb = require('tcomb');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ZeroOrPositiveIntegerType = (0, _tcomb.refinement)(_tcomb.Number, function (n) {
  return n >= 0 && n % 1 === 0;
}, 'ZeroOrPositiveIntegerType');

/**
 * @type StaRHsStatus
 */

var StaRHsStatus = exports.StaRHsStatus = function () {
  function StaRHsStatus(cycleShared, cycleReceived, cycleLeft, totalShared, totalReceived) {
    _classCallCheck(this, StaRHsStatus);

    ZeroOrPositiveIntegerType(cycleShared);
    ZeroOrPositiveIntegerType(cycleReceived);
    ZeroOrPositiveIntegerType(cycleLeft);
    ZeroOrPositiveIntegerType(totalShared);
    ZeroOrPositiveIntegerType(totalReceived);
    this.cycleShared = cycleShared;
    this.cycleReceived = cycleReceived;
    this.cycleLeft = cycleLeft;
    this.totalShared = totalShared;
    this.totalReceived = totalReceived;
    this.$context = StaRHsStatusContext;
  }

  /**
   * @param {{cycleShared: {Number}, cycleReceived: {Number}, cycleLeft: {Number}, totalShared: {Number}, totalReceived: {Number}}} data
   * @returns {StaRHsStatus}
   */


  _createClass(StaRHsStatus, null, [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      var cycleShared = data.cycleShared,
          cycleReceived = data.cycleReceived,
          cycleLeft = data.cycleLeft,
          totalShared = data.totalShared,
          totalReceived = data.totalReceived;

      return new StaRHsStatus(cycleShared, cycleReceived, cycleLeft, totalShared, totalReceived);
    }
  }]);

  return StaRHsStatus;
}();

var StaRHsStatusContext = exports.StaRHsStatusContext = 'https://github.com/ResourcefulHumans/staRHs-models#StaRHsStatus';
var StaRHsStatusType = exports.StaRHsStatusType = (0, _tcomb.irreducible)('StaRHsStatusType', function (x) {
  return x instanceof StaRHsStatus;
});